diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderBlocks.java b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
similarity index 78%
rename from game/client/src/main/java/net/minecraft/client/render/RenderBlocks.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
index 959d7597a..097fe7176 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderBlocks.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
@@ -1,23 +1,58 @@
-package net.minecraft.client.render;
+package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.render.LightingCache;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.phys.AABB;
-import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
-import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
-public class RenderBlocks
+import static net.minecraft.client.render.block.model.BlockModel.FULL_CUBE_THRESHOLD;
+import static net.minecraft.client.render.block.model.BlockModel.SIDE_LIGHT_MULTIPLIER;
+
+public final class RenderBlocks
 {
+    public final Minecraft mc;
+    public IconCoordinate overrideBlockTexture;
+    public boolean flipTexture;
+    public boolean renderAllFaces;
+    public byte renderBitMask;
+    public boolean useInventoryTint;
+    public int uvRotateEast;
+    public int uvRotateWest;
+    public int uvRotateSouth;
+    public int uvRotateNorth;
+    public int uvRotateTop;
+    public int uvRotateBottom;
+    public boolean enableAO;
+    public float colorRedTopLeft;
+    public float colorRedBottomLeft;
+    public float colorRedBottomRight;
+    public float colorRedTopRight;
+    public float colorGreenTopLeft;
+    public float colorGreenBottomLeft;
+    public float colorGreenBottomRight;
+    public float colorGreenTopRight;
+    public float colorBlueTopLeft;
+    public float colorBlueBottomLeft;
+    public float colorBlueBottomRight;
+    public float colorBlueTopRight;
+    public int lightmapCoordTopLeft;
+    public int lightmapCoordBottomLeft;
+    public int lightmapCoordBottomRight;
+    public int lightmapCoordTopRight;
+    public boolean overbright;
+    public LightingCache cache = new LightingCache();
 
-    public RenderBlocks(WorldSource worldSource)
+    public RenderBlocks()
     {
         overrideBlockTexture = null;
         flipTexture = false;
@@ -29,29 +64,32 @@ public class RenderBlocks
         uvRotateNorth = 0;
         uvRotateTop = 0;
         uvRotateBottom = 0;
-        field_22352_G = 1;
-        blockAccess = worldSource;
         renderBitMask = 0;
-        forceAO = false;
         this.mc = Minecraft.getMinecraft();
     }
 
-    public RenderBlocks()
-    {
-        overrideBlockTexture = null;
-        flipTexture = false;
+    public void resetRenderBlocks(){
         renderAllFaces = false;
+        enableAO = false;
+//        overbright = false;
         useInventoryTint = true;
+        flipTexture = false;
+        overrideBlockTexture = null;
         uvRotateEast = 0;
         uvRotateWest = 0;
         uvRotateSouth = 0;
         uvRotateNorth = 0;
         uvRotateTop = 0;
         uvRotateBottom = 0;
-        field_22352_G = 1;
         renderBitMask = 0;
-        forceAO = false;
-        this.mc = Minecraft.getMinecraft();
+    }
+
+    public void setRenderSide(Side side, boolean shouldRender){
+        if (!shouldRender){
+            renderBitMask |= (byte) (1 << side.getId());
+        } else {
+            renderBitMask &= (byte) ~(1 << side.getId());
+        }
     }
 
     public float getBlockBrightness(WorldSource blockAccess, int x, int y, int z)
@@ -68,154 +106,72 @@ public class RenderBlocks
         return blockAccess.getBrightness(x, y, z, Blocks.lightEmission[id]);
     }
 
-	public void renderBlockFallingSand(Tessellator tessellator, BlockModel<?> blockModel, Block<?> block, WorldSource world, int x, int y, int z) {
-		final boolean lightmap = LightmapHelper.isLightmapEnabled();
-		
-		float sideBottom = 1.0f;
-		float sideTop = 1.0f;
-		float sideNorthSouth = 1.0f;
-		float sideEastWest = 1.0f;
-		if(enableDirectionalLight) {
-			sideBottom = 0.5f;
-			sideTop = 1.0f;
-			sideNorthSouth = 0.8f;
-			sideEastWest = 0.6f;
-		}
-		
-		tessellator.startDrawingQuads();
-		
-		int meta = world.getBlockMetadata(x, y, z);
-		
-		final float brightnessInside = lightmap ? 1.0f : getBlockBrightness(world, x, y, z);
-		float brightness = 1.0f;
-		
-		final int lmcInside = lightmap ? block.getLightmapCoord(world, x, y, z) : 0;
-
-        final AABB bounds = block.getBounds();
-
-		// Bottom
-		if(lightmap) {
-			tessellator.setLightmapCoord(LightmapHelper.max(lmcInside, block.getLightmapCoord(world, x, y - 1, z)));
-		}else {
-			brightness = Math.max(getBlockBrightness(world, x, y - 1, z), brightnessInside);
-		}
-		tessellator.setColorOpaque_F(sideBottom * brightness, sideBottom * brightness, sideBottom * brightness);
-		renderBottomFace(tessellator, bounds, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.BOTTOM, meta));
-		
-		// Top
-		if(lightmap) {
-			tessellator.setLightmapCoord(LightmapHelper.max(lmcInside, block.getLightmapCoord(world, x, y + 1, z)));
-		}else {
-			brightness = Math.max(getBlockBrightness(world, x, y + 1, z), brightnessInside);	
-		}
-		tessellator.setColorOpaque_F(sideTop * brightness, sideTop * brightness, sideTop * brightness);
-		renderTopFace(tessellator, bounds, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.TOP, meta));
-		
-		// North
-		if(lightmap) {
-			tessellator.setLightmapCoord(LightmapHelper.max(lmcInside, block.getLightmapCoord(world, x, y, z - 1)));
-		}else {
-			brightness = Math.max(getBlockBrightness(world, x, y, z - 1), brightnessInside);
-		}
-		tessellator.setColorOpaque_F(sideNorthSouth * brightness, sideNorthSouth * brightness, sideNorthSouth * brightness);
-		renderNorthFace(tessellator, bounds, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.NORTH, meta));
-		
-		// South
-		if(lightmap) {
-			tessellator.setLightmapCoord(LightmapHelper.max(lmcInside, block.getLightmapCoord(world, x, y, z + 1)));
-		}else {
-			brightness = Math.max(getBlockBrightness(world, x, y, z + 1), brightnessInside);
-		}
-		tessellator.setColorOpaque_F(sideNorthSouth * brightness, sideNorthSouth * brightness, sideNorthSouth * brightness);
-		renderSouthFace(tessellator, bounds, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.SOUTH, meta));
-		
-		// West
-		if(lightmap) {
-			tessellator.setLightmapCoord(LightmapHelper.max(lmcInside, block.getLightmapCoord(world, x - 1, y, z)));
-		}else {
-			brightness = Math.max(getBlockBrightness(world, x - 1, y, z), brightnessInside);
-		}
-		tessellator.setColorOpaque_F(sideEastWest * brightness, sideEastWest * brightness, sideEastWest * brightness);
-		renderWestFace(tessellator, bounds, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.WEST, meta));
-		
-		// East
-		if(lightmap) {
-			tessellator.setLightmapCoord(LightmapHelper.max(lmcInside, block.getLightmapCoord(world, x + 1, y, z)));
-		}else {
-			brightness = Math.max(getBlockBrightness(world, x + 1, y, z), brightnessInside);
-		}
-		tessellator.setColorOpaque_F(sideEastWest * brightness, sideEastWest * brightness, sideEastWest * brightness);
-		renderEastFace(tessellator, bounds, -0.5, -0.5, -0.5, blockModel.getBlockTextureFromSideAndMetadata(Side.EAST, meta));
-		
-		tessellator.draw();
-	}
-
-    public boolean renderStandardBlock(Tessellator tessellator, BlockModel<?> blockModel, AABB bounds, int x, int y, int z)
+    public boolean renderStandardBlock(Tessellator tessellator, WorldSource worldSource, BlockModelStandard<?> blockModel, AABB bounds, int x, int y, int z)
     {
-        int color = BlockColorDispatcher.getInstance().getDispatch(blockModel.block).getWorldColor(blockAccess, x, y, z);
+        int color = BlockColorDispatcher.getInstance().getDispatch(blockModel.block).getWorldColor(worldSource, x, y, z, 0);
         float r = (float)(color >> 16 & 0xff) / 255F;
         float g = (float)(color >> 8 & 0xff) / 255F;
         float b = (float)(color & 0xff) / 255F;
-        return renderStandardBlock(tessellator, blockModel, bounds, x, y, z, r, g, b);
+        return renderStandardBlock(tessellator, worldSource, blockModel, bounds, x, y, z, r, g, b);
     }
 
     /**
      * @author CyborgCabbage
      * Thanks! :D
      */
-    public boolean renderStandardBlock(Tessellator tessellator, BlockModel<?> blockModel, AABB bounds, int x, int y, int z, float r, float g, float b) {
+    public boolean renderStandardBlock(Tessellator tessellator, WorldSource worldSource, BlockModelStandard<?> blockModel, AABB bounds, int x, int y, int z, float r, float g, float b) {
         this.enableAO = true;
-        int meta = blockAccess.getBlockMetadata(x, y, z);
-        cache.setupCache(blockModel.block, blockAccess, x, y, z);
+        int meta = worldSource.getBlockMetadata(x, y, z);
+        cache.setupCache(blockModel.block, worldSource, x, y, z);
         boolean somethingRendered = false;
         for (Side side : Side.sides){
-            somethingRendered |= renderSide(tessellator, blockModel, bounds, x, y, z, r, g, b, side, meta);
+            somethingRendered |= renderSide(tessellator, worldSource, blockModel, bounds, x, y, z, r, g, b, side, meta);
         }
         this.enableAO = false;
         return somethingRendered;
     }
-    public final boolean renderSide(Tessellator tessellator, BlockModel<?> blockModel, AABB bounds, int x, int y, int z, float r, float g, float b, Side side, int meta){
+    public boolean renderSide(Tessellator tessellator, WorldSource worldSource, BlockModelStandard<?> blockModel, AABB bounds, int x, int y, int z, float r, float g, float b, Side side, int meta){
         boolean useColor;
         switch (side){
             case BOTTOM:
-                useColor = blockModel.shouldSideBeColored(blockAccess, x, y, z, 0, meta);
-                return renderSide(tessellator, blockModel, bounds, x, y, z,
-                        useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,0, meta,
+                useColor = blockModel.shouldSideBeColored(worldSource, x, y, z, side, meta);
+                return renderSide(tessellator, worldSource, blockModel, bounds, x, y, z,
+                        useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,side, meta,
                         0, -1, 0, (float)bounds.minY,
                         0, 0, 1, (float)bounds.maxZ, (float)bounds.minZ,
                         -1, 0, 0, 1-(float)bounds.minX, 1-(float)bounds.maxX);
             case TOP:
-                useColor = blockModel.shouldSideBeColored(blockAccess, x, y, z, 1, meta);
-                return renderSide(tessellator, blockModel, bounds, x, y, z,
-                        useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,1, meta,
+                useColor = blockModel.shouldSideBeColored(worldSource, x, y, z, side, meta);
+                return renderSide(tessellator, worldSource, blockModel, bounds, x, y, z,
+                        useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,side, meta,
                         0,1,0, 1-(float)bounds.maxY,
                         0,0,1, (float)bounds.maxZ, (float)bounds.minZ,
                         1,0,0, (float)bounds.maxX, (float)bounds.minX);
             case NORTH:
-                useColor = blockModel.shouldSideBeColored(blockAccess, x, y, z, 2, meta);
-                return renderSide(tessellator, blockModel, bounds, x, y, z,
-                        useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,2, meta,
+                useColor = blockModel.shouldSideBeColored(worldSource, x, y, z, side, meta);
+                return renderSide(tessellator, worldSource, blockModel, bounds, x, y, z,
+                        useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,side, meta,
                         0,0,-1, (float)bounds.minZ,
                         -1,0,0, 1-(float)bounds.minX, 1-(float)bounds.maxX,
                         0,1,0, (float)bounds.maxY, (float)bounds.minY);
             case SOUTH:
-                useColor = blockModel.shouldSideBeColored(blockAccess, x, y, z, 3, meta);
-                return renderSide(tessellator, blockModel, bounds, x, y, z,
-                        useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,3, meta,
+                useColor = blockModel.shouldSideBeColored(worldSource, x, y, z, side, meta);
+                return renderSide(tessellator, worldSource, blockModel, bounds, x, y, z,
+                        useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,side, meta,
                         0,0,1, 1-(float)bounds.maxZ,
                         0,1,0, (float)bounds.maxY, (float)bounds.minY,
                         -1,0,0, 1-(float)bounds.minX, 1-(float)bounds.maxX);
             case WEST:
-                useColor = blockModel.shouldSideBeColored(blockAccess, x, y, z, 4, meta);
-                return renderSide(tessellator, blockModel, bounds, x, y, z,
-                        useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,4, meta,
+                useColor = blockModel.shouldSideBeColored(worldSource, x, y, z, side, meta);
+                return renderSide(tessellator, worldSource, blockModel, bounds, x, y, z,
+                        useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,side, meta,
                         -1,0,0, (float)bounds.minX,
                         0,0,1, (float)bounds.maxZ, (float)bounds.minZ,
                         0,1,0, (float)bounds.maxY, (float)bounds.minY);
             case EAST:
-                useColor = blockModel.shouldSideBeColored(blockAccess, x, y, z, 5, meta);
-                return renderSide(tessellator, blockModel, bounds, x, y, z,
-                        useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,5, meta,
+                useColor = blockModel.shouldSideBeColored(worldSource, x, y, z, side, meta);
+                return renderSide(tessellator, worldSource, blockModel, bounds, x, y, z,
+                        useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,side, meta,
                         1,0,0, 1-(float)bounds.maxX,
                         0,0,1, (float)bounds.maxZ, (float)bounds.minZ,
                         0,-1,0, 1-(float)bounds.minY, 1-(float)bounds.maxY);
@@ -228,48 +184,55 @@ public class RenderBlocks
      * @author CyborgCabbage
      * Thanks! :D
      */
-    public final boolean renderSide(Tessellator tessellator, BlockModel<?> blockModel, AABB bounds, int x, int y, int z, float r, float g, float b, int side, int meta,
-                                    int dirX, int dirY, int dirZ, float depth,
-                                    int topX, int topY, int topZ, float topP, float botP,
-                                    int lefX, int lefY, int lefZ, float lefP, float rigP
+    public boolean renderSide(Tessellator tessellator, WorldSource worldSource, BlockModelStandard<?> blockModel, AABB bounds, int x, int y, int z, float r, float g, float b, @NotNull Side side, int meta,
+                              int dirX, int dirY, int dirZ, float depth,
+                              int topX, int topY, int topZ, float topP, float botP,
+                              int lefX, int lefY, int lefZ, float lefP, float rigP
     ){
         IconCoordinate tex;
         if (this.overbright) {
-            tex = blockModel.getBlockOverbrightTexture(this.blockAccess, x, y, z, side);
+            tex = blockModel.getBlockOverbrightTexture(worldSource, x, y, z, side);
         } else {
-            tex = blockModel.getBlockTexture(this.blockAccess, x, y, z, Side.getSideById(side));
+            tex = blockModel.getBlockTexture(worldSource, x, y, z, side);
         }
-        if (tex == null || ((renderBitMask >> side) & 1) != 0) return false;
+        if (tex == null || ((renderBitMask >> side.getId()) & 1) != 0) return false;
 
         boolean rendered = false;
-        if (this.renderAllFaces || blockModel.shouldSideBeRendered(this.blockAccess, bounds, x+dirX, y+dirY, z+dirZ, side, meta)) {
+        if (this.renderAllFaces || blockModel.shouldSideBeRendered(worldSource, bounds, x+dirX, y+dirY, z+dirZ, side, meta)) {
         	
-            setupLighting(blockModel.block, x, y, z, r, g, b, side, meta,
-                    dirX, dirY, dirZ, depth,
+            setupLighting(blockModel.block, worldSource, x, y, z, r, g, b, side,
+                dirX, dirY, dirZ, depth,
                     topX, topY, topZ, topP, botP,
                     lefX, lefY, lefZ, lefP, rigP);
 
-            if (side == 0) {
-                this.renderBottomFace(tessellator, bounds, x, y, z, tex);
-            } else if (side == 1) {
-                this.renderTopFace(tessellator, bounds, x, y, z, tex);
-            } else if (side == 2) {
-                this.renderNorthFace(tessellator, bounds, x, y, z, tex);
-            } else if (side == 3) {
-                this.renderSouthFace(tessellator, bounds, x, y, z, tex);
-            } else if (side == 4) {
-                this.renderWestFace(tessellator, bounds, x, y, z, tex);
-            } else if (side == 5) {
-                this.renderEastFace(tessellator, bounds, x, y, z, tex);
+            switch (side) {
+                case BOTTOM:
+                    this.renderBottomFace(tessellator, bounds, x, y, z, tex);
+                    break;
+                case TOP:
+                    this.renderTopFace(tessellator, bounds, x, y, z, tex);
+                    break;
+                case NORTH:
+                    this.renderNorthFace(tessellator, bounds, x, y, z, tex);
+                    break;
+                case SOUTH:
+                    this.renderSouthFace(tessellator, bounds, x, y, z, tex);
+                    break;
+                case WEST:
+                    this.renderWestFace(tessellator, bounds, x, y, z, tex);
+                    break;
+                case EAST:
+                    this.renderEastFace(tessellator, bounds, x, y, z, tex);
+                    break;
             }
             rendered = true;
         }
         return rendered;
     }
-    public final void setupLighting(Block<?> block, int x, int y, int z, float r, float g, float b, int side, int meta,
-                                    int dirX, int dirY, int dirZ, float depth,
-                                    int topX, int topY, int topZ, float topP, float botP,
-                                    int lefX, int lefY, int lefZ, float lefP, float rigP){
+    public void setupLighting(Block<?> block, WorldSource worldSource, int x, int y, int z, float r, float g, float b, @NotNull Side side,
+                              int dirX, int dirY, int dirZ, float depth,
+                              int topX, int topY, int topZ, float topP, float botP,
+                              int lefX, int lefY, int lefZ, float lefP, float rigP){
     	boolean ao = mc.isAmbientOcclusionEnabled() && block.emission == 0;
         boolean isFullCube = depth <= FULL_CUBE_THRESHOLD;
 
@@ -285,7 +248,7 @@ public class RenderBlocks
     				dirZ2 = 0;
     			}
     			
-    			int lmc = LightmapHelper.getOverbrightLightmapCoord(blockAccess.getSavedLightValue(LightLayer.Sky, dirX2, dirY2, dirZ2));
+    			int lmc = LightmapHelper.getOverbrightLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, dirX2, dirY2, dirZ2));
     			
         		lightmapCoordTopLeft = lightmapCoordBottomLeft = lightmapCoordBottomRight = lightmapCoordTopRight = lmc;
     		}else {
@@ -329,9 +292,9 @@ public class RenderBlocks
         		}else {
         			int lmc;
                 	if(!isFullCube) {
-                		lmc = block.getLightmapCoord(blockAccess, x, y, z);
+                		lmc = block.getLightmapCoord(worldSource, x, y, z);
                 	}else {
-                		lmc = block.getLightmapCoord(blockAccess, x + dirX, y + dirY, z + dirZ);
+                		lmc = block.getLightmapCoord(worldSource, x + dirX, y + dirY, z + dirZ);
                 	}
             		lightmapCoordTopLeft = lightmapCoordBottomLeft = lightmapCoordBottomRight = lightmapCoordTopRight = lmc;
         		}
@@ -348,8 +311,6 @@ public class RenderBlocks
             lightBR = 1.0F;
             lightBL = 1.0F;
             lightTL = 1.0F;
-        } else if (this.field_22352_G <= 0) {
-            lightTL = lightBL = lightBR = lightTR = cache.getBrightness(dirX, dirY, dirZ);
         } else {
             if (ao) {
                 {
@@ -406,7 +367,7 @@ public class RenderBlocks
             }
         }
 
-        if (overbright || !enableDirectionalLight)
+        if (overbright || !BlockModel.ENABLE_DIRECTIONAL_LIGHTING)
         {
             this.colorRedTopLeft = this.colorRedBottomLeft = this.colorRedBottomRight = this.colorRedTopRight = r;
             this.colorGreenTopLeft = this.colorGreenBottomLeft = this.colorGreenBottomRight = this.colorGreenTopRight = g;
@@ -414,9 +375,9 @@ public class RenderBlocks
         }
         else
         {
-            this.colorRedTopLeft = this.colorRedBottomLeft = this.colorRedBottomRight = this.colorRedTopRight = r * SIDE_LIGHT_MULTIPLIER[side];
-            this.colorGreenTopLeft = this.colorGreenBottomLeft = this.colorGreenBottomRight = this.colorGreenTopRight = g * SIDE_LIGHT_MULTIPLIER[side];
-            this.colorBlueTopLeft = this.colorBlueBottomLeft = this.colorBlueBottomRight = this.colorBlueTopRight = b * SIDE_LIGHT_MULTIPLIER[side];
+            this.colorRedTopLeft = this.colorRedBottomLeft = this.colorRedBottomRight = this.colorRedTopRight = r * SIDE_LIGHT_MULTIPLIER[side.getId()];
+            this.colorGreenTopLeft = this.colorGreenBottomLeft = this.colorGreenBottomRight = this.colorGreenTopRight = g * SIDE_LIGHT_MULTIPLIER[side.getId()];
+            this.colorBlueTopLeft = this.colorBlueBottomLeft = this.colorBlueBottomRight = this.colorBlueTopRight = b * SIDE_LIGHT_MULTIPLIER[side.getId()];
         }
         float tl = topP * lightTL + (1 - topP) * lightBL;
         float tr = topP * lightTR + (1 - topP) * lightBR;
@@ -989,67 +950,4 @@ public class RenderBlocks
             tessellator.addVertexWithUV(xMax, yMax, zMax, uMin, vMin);
         }
     }
-
-    public void renderBlockAsItem(Tessellator tessellator, BlockModel<?> blockModel, float var2)
-    {
-        AABB bounds = blockModel.getBlockBoundsForItemRender();
-        GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
-        float var5 = 0.5F;
-        float var6 = 1.0F;
-        float var7 = 0.8F;
-        float var8 = 0.6F;
-        tessellator.startDrawingQuads();
-        tessellator.setColorRGBA_F(var6, var6, var6, var2);
-        this.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, blockModel.getBlockTextureFromSideAndMetadata(Side.BOTTOM, 0));
-        tessellator.setColorRGBA_F(var5, var5, var5, var2);
-        this.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, blockModel.getBlockTextureFromSideAndMetadata(Side.TOP, 0));
-        tessellator.setColorRGBA_F(var7, var7, var7, var2);
-        this.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, blockModel.getBlockTextureFromSideAndMetadata(Side.NORTH, 0));
-        this.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, blockModel.getBlockTextureFromSideAndMetadata(Side.SOUTH, 0));
-        tessellator.setColorRGBA_F(var8, var8, var8, var2);
-        this.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, blockModel.getBlockTextureFromSideAndMetadata(Side.WEST, 0));
-        this.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, blockModel.getBlockTextureFromSideAndMetadata(Side.EAST, 0));
-        tessellator.draw();
-        GL11.glTranslatef(0.5F, 0.5F, 0.5F);
-    }
-    public WorldSource blockAccess;
-    private final Minecraft mc;
-    public IconCoordinate overrideBlockTexture;
-    public boolean flipTexture;
-    public boolean renderAllFaces;
-    public byte renderBitMask;
-    public static boolean fancyGrass = true;
-
-    public static final float[] SIDE_LIGHT_MULTIPLIER = {0.5f, 1.0f, 0.8f, 0.8f, 0.6f, 0.6f};
-    public static final float FULL_CUBE_THRESHOLD = 1.0f / 16.0f;
-    public static boolean enableDirectionalLight = true;
-    public boolean useInventoryTint;
-    public int uvRotateEast;
-    public int uvRotateWest;
-    public int uvRotateSouth;
-    public int uvRotateNorth;
-    public int uvRotateTop;
-    public int uvRotateBottom;
-    public boolean enableAO;
-    public int field_22352_G;
-    public float colorRedTopLeft;
-    public float colorRedBottomLeft;
-    public float colorRedBottomRight;
-    public float colorRedTopRight;
-    public float colorGreenTopLeft;
-    public float colorGreenBottomLeft;
-    public float colorGreenBottomRight;
-    public float colorGreenTopRight;
-    public float colorBlueTopLeft;
-    public float colorBlueBottomLeft;
-    public float colorBlueBottomRight;
-    public float colorBlueTopRight;
-    public int lightmapCoordTopLeft;
-    public int lightmapCoordBottomLeft;
-    public int lightmapCoordBottomRight;
-    public int lightmapCoordTopRight; 
-    public boolean overbright;
-    public boolean forceAO;
-    public RenderBlockCache cache = new RenderBlockCache();
-
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java
index a6aa5e9ba..d53a766c6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java
@@ -1,12 +1,12 @@
 package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.BlockEntityRenderDispatcher;
+import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.model.ModelBase;
 import net.minecraft.client.render.model.ModelBoat;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.client.render.blockentity.TileEntityRendererFlag;
+import net.minecraft.client.render.tileentity.TileEntityRendererFlag;
 import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
@@ -22,7 +22,7 @@ public class EntityRendererBoat extends EntityRenderer<EntityBoat>
     {
         shadowSize = 0.5F;
         modelBoat = new ModelBoat();
-        flagRenderer.setRenderDispatcher(BlockEntityRenderDispatcher.instance);
+        flagRenderer.setRenderDispatcher(TileEntityRenderDispatcher.instance);
     }
 
     @Override
@@ -63,7 +63,7 @@ public class EntityRendererBoat extends EntityRenderer<EntityBoat>
         GL11.glScalef(1.0F / f4, 1.0F / f4, 1.0F / f4);
         bindTexture("/assets/minecraft/textures/entity/boat.png");
         GL11.glScalef(-1F, -1F, 1.0F);
-        modelBoat.render(0.0F, 0.0F, -0.1F, 0.0F, 0.0F, 0.0625F);
+        modelBoat.render(null, 0.0F, 0.0F, -0.1F, 0.0F, 0.0F, 0.0625F, partialTick);
         GL11.glPopMatrix();
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererCannonball.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererCannonball.java
index a4280e414..b10c0a198 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererCannonball.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererCannonball.java
@@ -9,29 +9,23 @@ import org.lwjgl.opengl.GL11;
 public class EntityRendererCannonball extends EntityRenderer<ProjectileCannonball>
 {
 
+    protected ModelBase modelCannonball;
+
     public EntityRendererCannonball()
     {
         modelCannonball = new ModelCannonball();
     }
 
-    public void RenderCannonball(ProjectileCannonball entity, double d, double d1, double d2,
-                                 float f)
+    @Override
+    public void render(Tessellator tessellator, ProjectileCannonball entity, double x, double y, double z,
+                       float yaw, float partialTick)
     {
         GL11.glPushMatrix();
-        GL11.glTranslatef((float)d, (float)d1, (float)d2);
-        GL11.glRotatef(180F - f, 0.0F, 1.0F, 0.0F);
+        GL11.glTranslatef((float)x, (float)y, (float)z);
+        GL11.glRotatef(180F - yaw, 0.0F, 1.0F, 0.0F);
         bindTexture("/assets/minecraft/textures/entity/cannonball.png");
         GL11.glScalef(-1F, -1F, 1.0F);
-        modelCannonball.render(0.0F, 0.0F, -0.1F, 0.0F, 0.0F, 0.03125F);
+        modelCannonball.render(null, 0.0F, 0.0F, -0.1F, 0.0F, 0.0F, 0.03125F, partialTick);
         GL11.glPopMatrix();
     }
-
-    @Override
-    public void render(Tessellator tessellator, ProjectileCannonball entity, double x, double y, double z,
-                       float yaw, float partialTick)
-    {
-        RenderCannonball(entity, x, y, z, yaw);
-    }
-
-    protected ModelBase modelCannonball;
 }
\ No newline at end of file
